Foreman - Bug #31364

undefined method "without_orchestration’
11/21/2020 10:48 PM - Greg C

Status: Closed
Priority: Normal
Assignee: Tomer Brisker
Category: Puppet Reports
Target version: 222
Difficulty: Fixed in Releases: 222,23.0
Triaged: No Found in Releases: 220
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/8160,
https://github.com/theforeman/foreman/p
ull/g161
Description

I'm not really well versed in Foreman, so, if | need to provide more detail, happy to do so, but | may need guidance.

| upgraded from 2.1 to 2.2 a couple of weeks ago. CPU usage is WAY higher for me, between ruby and postgres, to the point that |
had to go from 2 to 4 CPUs on the CentOS7 VM running foreman. | didn't have time to dig into why.

| don't do any provisioning from foreman. All | use it for is to collect reports/facts from puppet. It's been running and seems okay, but
that extra CPU made me wonder, so | finally looked.

production.log is getting spammed with tracebacks:

2020-11-21T22:36:30 [I|app|7b7cb68d] Started POST "/api/hosts/facts" for 10.58.75.23 at 2020-11-21
22:36:30 +0000

2020-11-21T22:36:30 [I|appl|7b7cb68d] Processing by Api::V2::HostsController#facts as JSON
2020-11-21T22:36:30 [I|appl|7b7cb68d] Parameters: {"facts"=>"[FILTERED]", "name"=>"REDACTEDHOSTNA
ME", "certname"=>"REDACTEDHOSTNAME", "apiv"=>"v2", "host"=>{"certname"=>"REDACTEDHOSTNAME", "name"
=>"REDACTEDHOSTNAME" } }

2020-11-21T22:36:31 [I|appl|7b7cb68d] Import facts for 'REDACTEDHOSTNAME' completed. Added: 5, Upda
ted: 20, Deleted 0 facts

2020-11-21T22:36:31 [W|appl|7b7cb68d] Action failed

2020-11-21T22:36:31 [I|appl|7b7cb68d] Backtrace for 'Action failed' error (NoMethodError): undefine
d method “without_orchestration' for #<Host::Managed:0x00007£4834768a80>

7b7cb68d | Did you mean? without_auditing

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activemodel-6.0.3.1/1lib/active_model/attr
ibute_methods.rb:432:in "method_missing'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.9.0/1ib/audited/auditor.rb:99:1
n ‘method_missing'

Tb7cb68d | /usr/share/foreman/app/services/host_fact_importer.rb:47:in " skipping_orchestration'
Tb7cb68d | /usr/share/foreman/app/services/host_fact_importer.rb:30:in " import_facts'

Tb7cb68d | /usr/share/foreman/app/controllers/api/v2/hosts_controller.rb:306:in " facts'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack—-6.0.3.1/1lib/action_controller/
metal/basic_implicit_render.rb:6:in "“send_action'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1ib/abstract_controlle
r/base.rb:195:in “process_action'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/action_controller/
metal/rendering.rb:30:in "“process_action'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/abstract_controlle
r/callbacks.rb:42:in “block in process_action'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.1/1ib/active_support/
callbacks.rb:112:in “block in run_callbacks'

Tb7cb68d | /usr/share/foreman/app/controllers/api/v2/base_controller.rb:181:in “disable_json_root
T

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.1/1lib/active_support/
callbacks.rb:121:in ‘block in run_callbacks'
Tb7cb68d | /usr/share/foreman/app/controllers/concerns/foreman/controller/timezone.rb:10:in "“set_
timezone'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.1/1ib/active_support/
callbacks.rb:121:in “block in run_callbacks'

Tb7cb68d | /usr/share/foreman/app/models/concerns/foreman/thread_session.rb:32:in ‘clear_thread'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.1/1ib/active_support/
callbacks.rb:121:in “block in run_callbacks'

Tb7cb68d | /usr/share/foreman/app/controllers/concerns/foreman/controller/topbar_sweeper.rb:12:in

‘set_topbar_sweeper_controller'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.1/1ib/active_support/
callbacks.rb:121:in "block in run_callbacks'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.9.0/1ib/audited/sweeper.rb:14:1
n “around'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.1/1ib/active_support/
callbacks.rb:121:in “block in run_callbacks'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/audited-4.9.0/1ib/audited/sweeper.rb:14:1
n “around'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.1/1ib/active_support/
callbacks.rb:121:in "block in run_callbacks'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.1/1ib/active_support/
callbacks.rb:139:in "run_callbacks'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/abstract_controlle
r/callbacks.rb:41:in "“process_action'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/action_controller/
metal/rescue.rb:22:in “process_action'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1ib/action_controller/
metal/instrumentation.rb:33:in “block in process_action'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.1/1lib/active_support/
notifications.rb:180:in “block in instrument'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.1/1ib/active_support/
notifications/instrumenter.rb:24:in " instrument'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.1/1ib/active_support/
notifications.rb:180:in "~ instrument'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1ib/action_controller/
metal/instrumentation.rb:32:in “process_action'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/action_controller/
metal/params_wrapper.rb:245:in ‘process_action'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activerecord-6.0.3.1/1ib/active_record/ra
ilties/controller_runtime.rb:27:in "process_action'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/abstract_controlle
r/base.rb:136:in “process'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionview-6.0.3.1/1ib/action_view/render
ing.rb:39:in “process'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/action_controller/
metal.rb:190:1in “dispatch’

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack—-6.0.3.1/1lib/action_controller/
metal.rb:254:in “dispatch’

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/action_dispatch/ro
uting/route_set.rb:50:in “dispatch’

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1ib/action_dispatch/ro
uting/route_set.rb:33:in “serve'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/action_dispatch/ro
uting/mapper.rb:18:in “block in <class:Constraints>'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/action_dispatch/ro
uting/mapper.rb:48:in " serve'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1ib/action_dispatch/jo
urney/router.rb:49:in “block in serve'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1ib/action_dispatch/jo
urney/router.rb:32:in “each'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/action_dispatch/jo
urney/router.rb:32:in ‘serve'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/action_dispatch/ro
uting/route_set.rb:834:in “call'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-dsl-2.2.9/1ib/apipie_dsl/static_di
spatcher.rb:67:in “call’

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.5.17/1lib/apipie/static_dis
patcher.rb:66:in “call'
Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.5.17/1lib/apipie/extractor/
recorder.rb:137:in “call'

7b7cb68d | /usr/share/foreman/lib/foreman/middleware/telemetry.rb:10:in ‘call’

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/apipie-rails-0.5.17/1lib/apipie/middleware
/checksum_in_headers.rb:27:in “call’

Tb7cb68d | /usr/share/foreman/lib/foreman/middleware/catch_json_parse_errors.rb:9:in “call'
Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/1ib/rack/tempfile_reaper.rb:15
:in “call!

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/1ib/rack/etag.rb:27:in ‘call'
Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/1ib/rack/conditional_get.rb:40
:in “call!

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/1lib/rack/head.rb:12:in “call'
Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1ib/action_dispatch/ht
tp/content_security_policy.rb:18:in “call’

Tb7cb68d | /usr/share/foreman/lib/foreman/middleware/logging_context_session.rb:22:in ‘call'
Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/1ib/rack/session/abstract/id.r
b:266:in "context'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/1ib/rack/session/abstract/id.r
b:260:in “call'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/action_dispatch/mi
ddleware/cookies.rb:648:in ‘call'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack—-6.0.3.1/1lib/action_dispatch/mi
ddleware/callbacks.rb:27:in “block in call'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.1/1ib/active_support/
callbacks.rb:101:in “run_callbacks'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1ib/action_dispatch/mi
ddleware/callbacks.rb:26:in “call'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/action_dispatch/mi
ddleware/actionable_exceptions.rb:17:in “call’

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack—-6.0.3.1/1lib/action_dispatch/mi
ddleware/debug_exceptions.rb:32:in “call'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/action_dispatch/mi
ddleware/show_exceptions.rb:33:in “call'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.1/1lib/rails/rack/logger.rb
:37:in “call_app'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.1/1ib/rails/rack/logger.rb
:28:in “call'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/sprockets-rails—-3.2.1/1ib/sprockets/rails
/quiet_assets.rb:13:in “call’

Tb7cb68d | /usr/share/foreman/lib/foreman/middleware/logging_context_request.rb:11l:in ‘call’
Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1ib/action_dispatch/mi
ddleware/remote_ip.rb:81l:in “call’

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/action_dispatch/mi
ddleware/request_id.rb:27:in “call'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/1lib/rack/method_override.rb:24
:in “call!

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/1lib/rack/runtime.rb:22:in ‘cal
ll

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/activesupport-6.0.3.1/1ib/active_support/
cache/strategy/local_cache_middleware.rb:29:in ‘call'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1lib/action_dispatch/mi
ddleware/executor.rb:14:in “call’

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1ib/action_dispatch/mi
ddleware/static.rb:126:in “call'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/1ib/rack/sendfile.rb:110:in ‘c
all'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/actionpack-6.0.3.1/1ib/action_dispatch/mi
ddleware/host_authorization.rb:76:in “call’

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/secure_headers-6.3.0/1ib/secure_headers/m
iddleware.rb:11:in “call'’

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.1/1ib/rails/engine.rb:527:
in “call'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.1/1ib/rails/railtie.rb:190
:in “public_send'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/railties-6.0.3.1/1ib/rails/railtie.rb:190
:in "method_missing'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/1lib/rack/urlmap.rb:74:in “bloc
k in call'
Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/1lib/rack/urlmap.rb:58:in "each

v

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/rack-2.2.3/1lib/rack/urlmap.rb:58:in “call

Tb7cb68d | /usr/share/passenger/phusion_passenger/rack/thread_handler_extension.rb:74:in "“process
_request'

Tb7cb68d | /usr/share/passenger/phusion_passenger/request_handler/thread_handler.rb:141:in "accep
t_and_process_next_request'

Tb7cb68d | /usr/share/passenger/phusion_passenger/request_handler/thread_handler.rb:109:in "main_
loop'

Tb7cb68d | /usr/share/passenger/phusion_passenger/request_handler.rb:455:in “block (3 levels) in
start_threads'

Tb7cb68d | /opt/theforeman/tfm/root/usr/share/gems/gems/logging-2.2.2/1ib/logging/diagnostic_cont
ext.rb:474:in “block in create_with_logging_context'
2020-11-21T22:36:31 [I|appl|7b7cb68d] Rendering api/v2/errors/custom_error.json.rabl within api/v
2/layouts/error_layout
2020-11-21T22:36:31 [I|appl|7b7cb68d] Rendered api/v2/errors/custom_error.json.rabl within api/v2
/layouts/error_layout (Duration: 0.2ms | Allocations: 67)
2020-11-21T22:36:31 [I|appl|l7b7cb68d] Completed 500 Internal Server Error in 892ms (Views: 0.8ms |
ActiveRecord: 232.9ms | Allocations: 253798)

From what | see, commits 5253d21ed7d690e80e595a075d06f96d2e211e8c and 6caadffdba581b798bad3b89bc0f6f60621112d7 on
https://github.com/theforeman/foreman introduced 'without_orchestration’, between 2.1.4 and 2.2.0, but | feel like something got
missed here, and I'm not sure what.

My puppetservers are using https://github.com/theforeman/puppet-foreman version 16.0.0 and its foreman::puppetmaster class to
config up reports/facts... so | don't think I'm doing anything weird or special here. "It just worked before the upgrade.”

Related issues:
Related to Foreman - Refactor #30127: Extract import_facts entry point from h... Closed

Associated revisions

Revision 20831319 - 11/29/2020 11:10 PM - Tomer Brisker

Fixes #31364 - Properly import facts when unattended false

The fact importer calls host.without_orchestration which is defined in
orchestration concern, however the concern is only included when

unattended true. Users who have the setting set to false will not be
able to import facts as the fact importer will fail to find this method.

History

#1 - 11/29/2020 02:10 PM - Tomer Brisker

- Related to Refactor #30127: Extract import_facts entry point from host class and create HostFactimporter added

#2 - 11/29/2020 02:11 PM - Tomer Brisker

By any chance do you have “:unattended: false™ configured in your /etc/foreman/settings.yaml file?

#3 - 11/29/2020 02:16 PM - Tomer Brisker

- Target version set to 2.2.2

#4 - 11/29/2020 02:33 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Tomer Brisker

- Pull request https://github.com/theforeman/foreman/pull/8160 added

#5 - 11/29/2020 04:23 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/8161 added

#6 - 11/29/2020 06:21 PM - Greg C

Tomer Brisker wrote:

By any chance do you have ":unattended: false’ configured in your /etc/foreman/settings.yaml file?
https://github.com/theforeman/foreman
https://github.com/theforeman/puppet-foreman

Correct. Very first setting,

:unattended: false

We don't provision with our foreman, we just capture puppet data for pretty pictures.

#7 - 11/29/2020 11:10 PM - The Foreman Bot
- Fixed in Releases 2.4.0 added

#8 - 11/30/2020 12:01 AM - Tomer Brisker
- Status changed from Ready For Testing to Closed

Applied in changeset foreman|208313190271a66f4f7a4df5tb2b584774a370c7.

#9 - 11/30/2020 08:15 AM - Tomer Brisker
- Fixed in Releases 2.2.2, 2.3.0 added
- Fixed in Releases deleted (2.4.0)

#10 - 11/30/2020 08:17 AM - Tomer Brisker

Thanks for reporting Greg! The fix will be included in 2.2.2 and 2.3.0, but until they are released you can apply the patch from
https://github.com/theforeman/foreman/commit/59fcc62528058091df7290b13f7d35f10a40f051.diff manually and restart your foreman to fix the issue.
